# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%global _jarsign_opts --skip=%{_javadir}
%global namedversion %{version}
%global cglib_asm_version 3.3.1

%bcond_without repolib

%define section free

Name:           cglib
Version:        2.2.2
Release:        2%{?dist}
Epoch:          0
Summary:        Code Generation Library
License:        ASL 2.0
URL:            http://cglib.sourceforge.net/
Group:          Development/Libraries/Java
%if 0
cvs -z3 -d:pserver:anonymous@cglib.cvs.sourceforge.net:/cvsroot/cglib export -D 20110920 -d cglib-2.2.2 cglib && tar cjf cglib-2.2.2.tar.bz2 cglib-2.2.2
%endif
Source0:        cglib-2.2.2.tar.bz2
Source1:        http://repo1.maven.org/maven2/cglib/cglib/2.2.2/cglib-2.2.2.pom
Source2:        http://repo1.maven.org/maven2/cglib/cglib-nodep/2.2.2/cglib-nodep-2.2.2.pom
Patch0:         cglib-2.2-TestEnhancer.patch
Patch1:		cglib-build_xml.patch
Patch2:         cglib-poms.patch
Obsoletes:      %{name}-nohook < %{epoch}:%{version}-%{release}
Provides:       %{name}-nohook = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       objectweb-asm >= 0:3.3.1
BuildRequires:  jpackage-utils
BuildRequires:  ant >= 0:1.6.2
BuildRequires:  jarjar
BuildRequires:  junit >= 0:3.7
BuildRequires:  maven2-plugin-deploy
BuildRequires:  objectweb-asm >= 0:3.3.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
cglib is a powerful, high performance and quality 
Code Generation Library, It is used to extend JAVA 
classes and implements interfaces at runtime.

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%{__cp} -p %{SOURCE1} %{SOURCE2} .
%patch0 -p1 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%{_bindir}/find -name "*.jar" | %{_bindir}/xargs -t %{__rm}

pushd lib
%{__ln_s} `%{_bindir}/build-classpath ant` ant.jar
%{__ln_s} `%{_bindir}/build-classpath objectweb-asm/asm` asm-%{cglib_asm_version}.jar
%{__ln_s} `%{_bindir}/build-classpath objectweb-asm/asm-commons` asm-commons-%{cglib_asm_version}.jar
%{__ln_s} `%{_bindir}/build-classpath objectweb-asm/asm-util` asm-util-%{cglib_asm_version}.jar
%{__ln_s} `%{_bindir}/build-classpath jarjar` jarjar.jar
%{__ln_s} `%{_bindir}/build-classpath junit` junit.jar
popd

( cat << EO_JP
grant codeBase "file:/-"{
  permission java.security.AllPermission;
};
EO_JP
) > java.policy

%build
export CLASSPATH=`%{_bindir}/build-classpath objectweb-asm/asm objectweb-asm/asm-commons objectweb-asm/asm-util jarjar junit`
export OPT_JAR_LIST=:
%{ant} -Dbuild.sysclasspath=first dist test

%install
%{__rm} -rf %{buildroot}

export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=cglib-%{namedversion}.pom -Dfile=dist/cglib-%{namedversion}.jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=cglib-%{namedversion}.pom -Dfile=dist/cglib-docs-%{namedversion}.jar -Dclassifier=javadoc -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=cglib-%{namedversion}.pom -Dfile=dist/cglib-src-%{namedversion}.jar -Dclassifier=sources -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=cglib-nodep-%{namedversion}.pom -Dfile=dist/cglib-nodep-%{namedversion}.jar -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=cglib-nodep-%{namedversion}.pom -Dfile=dist/cglib-docs-%{namedversion}.jar -Dclassifier=javadoc -Durl=${URL} -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=cglib-nodep-%{namedversion}.pom -Dfile=dist/cglib-src-%{namedversion}.jar -Dclassifier=sources -Durl=${URL} -DrepositoryId=oss-releases

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
pushd %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -p cglib/cglib/%{namedversion}/cglib-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p cglib/cglib/%{namedversion}/cglib-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar
%{__cp} -p cglib/cglib/%{namedversion}/cglib-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%{__cp} -p cglib/cglib-nodep/%{namedversion}/cglib-nodep-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-nodep-%{namedversion}.jar
popd
pushd %{buildroot}%{_javadir}
%{__ln_s} %{name}-%{namedversion}-javadoc.jar %{name}-nodep-%{namedversion}-javadoc.jar
%{__ln_s} %{name}-%{namedversion}-sources.jar %{name}-nodep-%{namedversion}-sources.jar
popd
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*.jar; do %{__ln_s} ${jar} `/bin/echo $jar | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
pushd %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -p cglib/cglib/%{namedversion}/cglib-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%{__cp} -p cglib/cglib-nodep/%{namedversion}/cglib-nodep-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}-nodep.pom
popd
%add_to_maven_depmap cglib cglib %{namedversion} JPP %{name}
%add_to_maven_depmap cglib cglib-nodep %{namedversion} JPP %{name}-nodep

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr docs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# demo
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}
%{__cp} -pr src/proxy/samples %{buildroot}%{_datadir}/%{name}

%if %without repolib
%{__rm} -r %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE NOTICE README
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-javadoc.jar
%{_javadir}*/%{name}-javadoc.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_javadir}*/%{name}-nodep-%{namedversion}.jar
%{_javadir}*/%{name}-nodep.jar
%{_javadir}*/%{name}-nodep-%{namedversion}-javadoc.jar
%{_javadir}*/%{name}-nodep-javadoc.jar
%{_javadir}*/%{name}-nodep-%{namedversion}-sources.jar
%{_javadir}*/%{name}-nodep-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_datadir}/maven2/poms/JPP-%{name}-nodep.pom
%{_mavendepmapfragdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Sep 20 2011 David Walluck <dwalluck@redhat.com> 0:2.2.2-2
- fix repolib option

* Tue Sep 20 2011 David Walluck <dwalluck@redhat.com> 0:2.2.2-1
- 2.2.2
- fix bad nodep jar
- fix bad poms
- add and deploy javadoc and sources jars
- add some docs
- remove bad upload.sh
- add proper Requires to main, demo, and javadoc packages
- fix bad repolib file owership
- fix bad docs copying

* Tue Sep 13 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.6
- Change R: objectweb-asm31 to R:objectweb-asm for build purpose

* Fri Aug 19 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.5
- Build with unsign jar (JBPAPP-6892)

* Tue May 24 2011 Yiqiao Wang <yiwang@redhat.com> - 0:2.2-5.4
- Change R objectweb-asm to R objectweb-asm31

* Tue Jan 18 2011 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.3
- Rebuild

* Tue Dec 21 2010 Fernando Nasser <fnasser@redhat.com> - 0:2.2-5.2
- Add cglib-nodep artifact

* Mon Nov 15 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.1.1.1.2
- Add content of maven2-brew

* Mon Nov 15 2010 Permaine Cheung <pcheung@redhat.com> - 0:2.2-5.1.1.1.1
- Add upload.sh to repolib
- Fix %%files for signed jars

* Fri May 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.2-5.1.1.1
- rebuilt

* Tue Apr 20 2010 Hui Wang <huwang@redhat.com> 0:2.2-5.1.1
- Rebuild to generate signed jar

* Thu Mar 11 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.2-5.1
- Merge from RHEL-4-EP-5

* Wed Mar 10 2010 David Walluck <dwalluck@redhat.com> 0:2.2-5
- add depmap frag for cglib-nodep
- version nodep jar

* Wed Sep 2 2009 Martha Benitez <mbenitez@redhat.com> 0:2.2-4
- Add patch to include version in manifest.mf
- Add pom.xml file to repolib

* Wed Jul 15 2009 Fernando Nasser <fnasser@redhat.com> 0:2.2-3
- Add backward compatibility cglib-nodep.jar symlink

* Wed Jul 08 2009 David Walluck <dwalluck@redhat.com> 0:2.2-2
- remove hook/nohook distinction
- add pom

* Tue Jul 07 2009 David Walluck <dwalluck@redhat.com> 0:2.2-1
- 2.2

* Thu Oct 09 2008 David Walluck <dwalluck@redhat.com> 0:2.1.3-4
- fix repolib

* Sat Jun 21 2008 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-3
- Rebuild for JPP 5.0

* Tue Apr 15 2008 David Walluck <dwalluck@redhat.com> 0:2.1.3-2jpp.ep1.3
- fix cglib-debug output directory in TestAll.java

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp.ep1.1
- Rebuild

* Thu Mar 08 2007 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp.el4ep1.4
- Make aspectwerks optional (run-time)

* Fri Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.el4ep1.3
- Add -brew suffix

* Fri Feb 16 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.el4ep1.2
- Change name of repository directory in component-info.xml and in the spec

* Fri Feb 16 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.1.3-2jpp.el4ep1.1
- Add repolib support

* Tue Feb 28 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp_3rh
- Rebuild

* Tue Feb 28 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp_2rh
- Rebuild in full

* Tue Feb 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1.3-2jpp_1rh
- First Red Hat build -- without hook for bootstraping jmock

* Fri Feb 17 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.1.3-2jpp
- Create option --without hook to build without requiring aspectwerkz
- Create new subpackage cglib-nohook containing cglib-nohook.jar
- Main package also provides cglib-nohook
- Add demo subpackage

* Fri Nov 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.3-1jpp
- Upgrade to 2.1_3
- asm2 is BuildRequired too, because our newer jarjar needs it

* Tue Mar 15 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.0-1jpp
- Adapt to upgraded asm 1.5.3 (no src patching required)

* Tue Feb 01 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-2jpp
- Adapt to upgraded asm 1.4.3 (patch required)

* Wed Sep 08 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-1jpp
- Upgrade to 2.0.2 (bug fix required)
- Drop cglib-full.jar (identical to cglib.jar in our build)
- Add manual generated offline with "maven xdoc:transform"

* Tue Sep 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-3jpp
- Include cglib-full.jar in package

* Mon Sep 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-2jpp
- Upgrade to Ant 1.6.X
- Build with ant-1.6.2
- Relax some versioned dependencies
- Add missing BuildReq junit
- Upgraded to 2.0.1 and built with aspectwerkz-0.9 on Sat Jun 12 2004 
  by Ralph Apel <r.apel at r-apel.de> as 0:2.0.1-1jpp

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-3jpp
- Build with ant-1.6.2
- Dropped ant from CLASSPATH
- Relaxed jpackage-utils BuildReq

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.0-2jpp
- Upgrade to Ant 1.6.X

* Sat Feb 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-1jpp
- First JPackage release
